<?php

$latin2_to_utf8_table = array(
    0x0 => array(0x0),
    0x1 => array(0x1),
    0x2 => array(0x2),
    0x3 => array(0x3),
    0x4 => array(0x4),
    0x5 => array(0x5),
    0x6 => array(0x6),
    0x7 => array(0x7),
    0x8 => array(0x8),
    0x9 => array(0x9),
    0xa => array(0xa),
    0xb => array(0xb),
    0xc => array(0xc),
    0xd => array(0xd),
    0xe => array(0xe),
    0xf => array(0xf),
    0x10 => array(0x10),
    0x11 => array(0x11),
    0x12 => array(0x12),
    0x13 => array(0x13),
    0x14 => array(0x14),
    0x15 => array(0x15),
    0x16 => array(0x16),
    0x17 => array(0x17),
    0x18 => array(0x18),
    0x19 => array(0x19),
    0x1a => array(0x1a),
    0x1b => array(0x1b),
    0x1c => array(0x1c),
    0x1d => array(0x1d),
    0x1e => array(0x1e),
    0x1f => array(0x1f),
    0x20 => array(0x20),
    0x21 => array(0x21),
    0x22 => array(0x22),
    0x23 => array(0x23),
    0x24 => array(0x24),
    0x25 => array(0x25),
    0x26 => array(0x26),
    0x27 => array(0x27),
    0x28 => array(0x28),
    0x29 => array(0x29),
    0x2a => array(0x2a),
    0x2b => array(0x2b),
    0x2c => array(0x2c),
    0x2d => array(0x2d),
    0x2e => array(0x2e),
    0x2f => array(0x2f),
    0x30 => array(0x30),
    0x31 => array(0x31),
    0x32 => array(0x32),
    0x33 => array(0x33),
    0x34 => array(0x34),
    0x35 => array(0x35),
    0x36 => array(0x36),
    0x37 => array(0x37),
    0x38 => array(0x38),
    0x39 => array(0x39),
    0x3a => array(0x3a),
    0x3b => array(0x3b),
    0x3c => array(0x3c),
    0x3d => array(0x3d),
    0x3e => array(0x3e),
    0x3f => array(0x3f),
    0x40 => array(0x40),
    0x41 => array(0x41),
    0x42 => array(0x42),
    0x43 => array(0x43),
    0x44 => array(0x44),
    0x45 => array(0x45),
    0x46 => array(0x46),
    0x47 => array(0x47),
    0x48 => array(0x48),
    0x49 => array(0x49),
    0x4a => array(0x4a),
    0x4b => array(0x4b),
    0x4c => array(0x4c),
    0x4d => array(0x4d),
    0x4e => array(0x4e),
    0x4f => array(0x4f),
    0x50 => array(0x50),
    0x51 => array(0x51),
    0x52 => array(0x52),
    0x53 => array(0x53),
    0x54 => array(0x54),
    0x55 => array(0x55),
    0x56 => array(0x56),
    0x57 => array(0x57),
    0x58 => array(0x58),
    0x59 => array(0x59),
    0x5a => array(0x5a),
    0x5b => array(0x5b),
    0x5c => array(0x5c),
    0x5d => array(0x5d),
    0x5e => array(0x5e),
    0x5f => array(0x5f),
    0x60 => array(0x60),
    0x61 => array(0x61),
    0x62 => array(0x62),
    0x63 => array(0x63),
    0x64 => array(0x64),
    0x65 => array(0x65),
    0x66 => array(0x66),
    0x67 => array(0x67),
    0x68 => array(0x68),
    0x69 => array(0x69),
    0x6a => array(0x6a),
    0x6b => array(0x6b),
    0x6c => array(0x6c),
    0x6d => array(0x6d),
    0x6e => array(0x6e),
    0x6f => array(0x6f),
    0x70 => array(0x70),
    0x71 => array(0x71),
    0x72 => array(0x72),
    0x73 => array(0x73),
    0x74 => array(0x74),
    0x75 => array(0x75),
    0x76 => array(0x76),
    0x77 => array(0x77),
    0x78 => array(0x78),
    0x79 => array(0x79),
    0x7a => array(0x7a),
    0x7b => array(0x7b),
    0x7c => array(0x7c),
    0x7d => array(0x7d),
    0x7e => array(0x7e),
    0x7f => array(0x7f),
    0x80 => array(0xc2, 0x80),
    0x81 => array(0xc2, 0x81),
    0x82 => array(0xc2, 0x82),
    0x83 => array(0xc2, 0x83),
    0x84 => array(0xc2, 0x84),
    0x85 => array(0xc2, 0x85),
    0x86 => array(0xc2, 0x86),
    0x87 => array(0xc2, 0x87),
    0x88 => array(0xc2, 0x88),
    0x89 => array(0xc2, 0x89),
    0x8a => array(0xc2, 0x8a),
    0x8b => array(0xc2, 0x8b),
    0x8c => array(0xc2, 0x8c),
    0x8d => array(0xc2, 0x8d),
    0x8e => array(0xc2, 0x8e),
    0x8f => array(0xc2, 0x8f),
    0x90 => array(0xc2, 0x90),
    0x91 => array(0xc2, 0x91),
    0x92 => array(0xc2, 0x92),
    0x93 => array(0xc2, 0x93),
    0x94 => array(0xc2, 0x94),
    0x95 => array(0xc2, 0x95),
    0x96 => array(0xc2, 0x96),
    0x97 => array(0xc2, 0x97),
    0x98 => array(0xc2, 0x98),
    0x99 => array(0xc2, 0x99),
    0x9a => array(0xc2, 0x9a),
    0x9b => array(0xc2, 0x9b),
    0x9c => array(0xc2, 0x9c),
    0x9d => array(0xc2, 0x9d),
    0x9e => array(0xc2, 0x9e),
    0x9f => array(0xc2, 0x9f),
    0xa0 => array(0xc2, 0xa0),
    0xa1 => array(0xc4, 0x84),
    0xa2 => array(0xcb, 0x98),
    0xa3 => array(0xc5, 0x81),
    0xa4 => array(0xc2, 0xa4),
    0xa5 => array(0xc4, 0xbd),
    0xa6 => array(0xc5, 0x9a),
    0xa7 => array(0xc2, 0xa7),
    0xa8 => array(0xc2, 0xa8),
    0xa9 => array(0xc5, 0xa0),
    0xaa => array(0xc5, 0x9e),
    0xab => array(0xc5, 0xa4),
    0xac => array(0xc5, 0xb9),
    0xad => array(0xc2, 0xad),
    0xae => array(0xc5, 0xbd),
    0xaf => array(0xc5, 0xbb),
    0xb0 => array(0xc2, 0xb0),
    0xb1 => array(0xc4, 0x85),
    0xb2 => array(0xcb, 0x9b),
    0xb3 => array(0xc5, 0x82),
    0xb4 => array(0xc2, 0xb4),
    0xb5 => array(0xc4, 0xbe),
    0xb6 => array(0xc5, 0x9b),
    0xb7 => array(0xcb, 0x87),
    0xb8 => array(0xc2, 0xb8),
    0xb9 => array(0xc5, 0xa1),
    0xba => array(0xc5, 0x9f),
    0xbb => array(0xc5, 0xa5),
    0xbc => array(0xc5, 0xba),
    0xbd => array(0xcb, 0x9d),
    0xbe => array(0xc5, 0xbe),
    0xbf => array(0xc5, 0xbc),
    0xc0 => array(0xc5, 0x94),
    0xc1 => array(0xc3, 0x81),
    0xc2 => array(0xc3, 0x82),
    0xc3 => array(0xc4, 0x82),
    0xc4 => array(0xc3, 0x84),
    0xc5 => array(0xc4, 0xb9),
    0xc6 => array(0xc4, 0x86),
    0xc7 => array(0xc3, 0x87),
    0xc8 => array(0xc4, 0x8c),
    0xc9 => array(0xc3, 0x89),
    0xca => array(0xc4, 0x98),
    0xcb => array(0xc3, 0x8b),
    0xcc => array(0xc4, 0x9a),
    0xcd => array(0xc3, 0x8d),
    0xce => array(0xc3, 0x8e),
    0xcf => array(0xc4, 0x8e),
    0xd0 => array(0xc4, 0x90),
    0xd1 => array(0xc5, 0x83),
    0xd2 => array(0xc5, 0x87),
    0xd3 => array(0xc3, 0x93),
    0xd4 => array(0xc3, 0x94),
    0xd5 => array(0xc5, 0x90),
    0xd6 => array(0xc3, 0x96),
    0xd7 => array(0xc3, 0x97),
    0xd8 => array(0xc5, 0x98),
    0xd9 => array(0xc5, 0xae),
    0xda => array(0xc3, 0x9a),
    0xdb => array(0xc5, 0xb0),
    0xdc => array(0xc3, 0x9c),
    0xdd => array(0xc3, 0x9d),
    0xde => array(0xc5, 0xa2),
    0xdf => array(0xc3, 0x9f),
    0xe0 => array(0xc5, 0x95),
    0xe1 => array(0xc3, 0xa1),
    0xe2 => array(0xc3, 0xa2),
    0xe3 => array(0xc4, 0x83),
    0xe4 => array(0xc3, 0xa4),
    0xe5 => array(0xc4, 0xba),
    0xe6 => array(0xc4, 0x87),
    0xe7 => array(0xc3, 0xa7),
    0xe8 => array(0xc4, 0x8d),
    0xe9 => array(0xc3, 0xa9),
    0xea => array(0xc4, 0x99),
    0xeb => array(0xc3, 0xab),
    0xec => array(0xc4, 0x9b),
    0xed => array(0xc3, 0xad),
    0xee => array(0xc3, 0xae),
    0xef => array(0xc4, 0x8f),
    0xf0 => array(0xc4, 0x91),
    0xf1 => array(0xc5, 0x84),
    0xf2 => array(0xc5, 0x88),
    0xf3 => array(0xc3, 0xb3),
    0xf4 => array(0xc3, 0xb4),
    0xf5 => array(0xc5, 0x91),
    0xf6 => array(0xc3, 0xb6),
    0xf7 => array(0xc3, 0xb7),
    0xf8 => array(0xc5, 0x99),
    0xf9 => array(0xc5, 0xaf),
    0xfa => array(0xc3, 0xba),
    0xfb => array(0xc5, 0xb1),
    0xfc => array(0xc3, 0xbc),
    0xfd => array(0xc3, 0xbd),
    0xfe => array(0xc5, 0xa3),
    0xff => array(0xcb, 0x99),
    );
    


$utf8_to_latin2_table = array(
    0x0104,
    0x02D8,
    0x0141,
    0x00A4,
    0x013D,
    0x015A,
    0x00A7,
    0x00A8,
    0x0160,
    0x015E,
    0x0164,
    0x0179,
    0x00AD,
    0x017D,
    0x017B,
    0x00B0,
    0x0105,
    0x02DB,
    0x0142,
    0x00B4,
    0x013E,
    0x015B,
    0x02C7,
    0x00B8,
    0x0161,
    0x015F,
    0x0165,
    0x017A,
    0x02DD,
    0x017E,
    0x017C,
    0x0154,
    0x00C1,
    0x00C2,
    0x0102,
    0x00C4,
    0x0139,
    0x0106,
    0x00C7,
    0x010C,
    0x00C9,
    0x0118,
    0x00CB,
    0x011A,
    0x00CD,
    0x00CE,
    0x010E,
    0x0110,
    0x0143,
    0x0147,
    0x00D3,
    0x00D4,
    0x0150,
    0x00D6,
    0x00D7,
    0x0158,
    0x016E,
    0x00DA,
    0x0170,
    0x00DC,
    0x00DD,
    0x0162,
    0x00DF,
    0x0155,
    0x00E1,
    0x00E2,
    0x0103,
    0x00E4,
    0x013A,
    0x0107,
    0x00E7,
    0x010D,
    0x00E9,
    0x0119,
    0x00EB,
    0x011B,
    0x00ED,
    0x00EE,
    0x010F,
    0x0111,
    0x0144,
    0x0148,
    0x00F3,
    0x00F4,
    0x0151,
    0x00F6,
    0x00F7,
    0x0159,
    0x016F,
    0x00FA,
    0x0171,
    0x00FC,
    0x00FD,
    0x0163,
    0x02D9
    );



function byte_latin2_to_utf8($b) {
    global $latin2_to_utf8_table;

    if ($b < 0x80) {
	return array($b);
    }
    if ($b < 0xa1) {
	return array(0xc2, $b);
    }
    return $latin2_to_utf8_table[$b - 0xa1];
}


function latin2_to_utf8($str) {
    global $latin2_to_utf8_table;

    $res = "";
    for ($i = 0; $i < strlen($str); $i++) {
	$bs = $latin2_to_utf8_table[ord($str{$i})];
	foreach ($bs as $b) {
	    $res .= chr($b);
	}
    }
    return $res;
}



function utf8_to_bits($str, &$i) {

    if ((ord($str{$i}) & 0x80) == 0) {
	return (ord($str{$i++}) & 0x7f);
    }

    if ((ord($str{$i}) & 0x20) == 0) {
	return ((ord($str{$i++}) & 0x1f) << 6) + (ord($str{$i++}) & 0x3f);
    }

    if ((ord($str{$i}) & 0x10) == 0) {
	return ((ord($str{$i++}) & 0x0f) << 12) + ((ord($str{$i++}) & 0x3f) << 6)  + (ord($str{$i++}) & 0x3f);
    }
    
    if ((ord($str{$i}) & 0x08) == 0) {
	return ((ord($str{$i++}) & 0x07) << 18) + ((ord($str{$i++}) & 0x3f) << 12) + ((ord($str{$i++}) & 0x3f) << 6)  + (ord($str{$i++}) & 0x3f);
    }

    return (ord($str{$i++}) & 0x7f);
}




function utf8_to_latin2($str) {
    global $utf8_to_latin2_table;

    $res = "";
    $i = 0;
    while ($i < strlen($str)) {
	//print "$i-";
	$b = utf8_to_bits($str, &$i);
	//print "$i: $b<br>";
	if (in_array($b, $utf8_to_latin2_table)) {
	    $index = array_search($b, $utf8_to_latin2_table);
	    $res .= chr($index + 0xa1);
	} else {
	    $res .= chr($b);
	}
    }	
    return $res;
}



/*
function utf8_to_bits($str) {
    if (ord($str{0}) & 0x80 == 0) {
	return ord($str{0}) & 7f;
    }

    if (ord($str{0}) & 0x20 == 0) {
	return ((ord($str{0}) & 1f) * 0x40) + (ord(str{1}) & 3f);
    }

    if (ord($str{0}) & 0x10 == 0) {
	return ((ord($str{0}) & 0f) * 0x1000) + ((ord(str{1}) & 3f) * 0x40)  + (ord(str{2}) & 3f);
    }
    
    if (ord($str{0}) & 0x08 == 0) {
	return ((ord($str{0}) & 07) * 0x40000) + ((ord($str{1}) & 3f) * 0x1000) + ((ord(str{2}) & 3f) * 0x40)  + (ord(str{3}) & 3f);
    }    
}
*/

?>
